Index: ThirdParty/mpqc_open/src/lib/util/class/Makefile.am
===================================================================
--- ThirdParty/mpqc_open/src/lib/util/class/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
+++ ThirdParty/mpqc_open/src/lib/util/class/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
@@ -0,0 +1,60 @@
+LIBSCCLASSSOURCES = \
+		class.cc scexception.cc
+
+LIBSCCLASSHEADERS = \
+		class.h proxy.h scexception.h
+
+lib_LTLIBRARIES +=
+noinst_LTLIBRARIES += libSCclass.la
+libSCclass_la_includedir = $(includedir)/util/class
+libSCclass_la_CPPFLAGS = $(AM_CPPFLAGS)
+libSCclass_la_LDFLAGS = $(AM_LDFLAGS)
+libSCclass_la_LIBADD =
+
+nobase_libSCclass_la_include_HEADERS = ${LIBSCCLASSHEADERS}
+
+## Define the source file list for the "libexample-@MPQC_API_VERSION@.la"
+## target.  Note that @MPQC_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libSCclass_la_SOURCES = ${LIBSCCLASSSOURCES}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+#libSCclass_la_LDFLAGS += $(AM_LDFLAGS) -version-info $(MPQC_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+#libSCclass_libincludedir = $(libdir)/util/class/include
+#nodist_libSCclass_libinclude_HEADERS = $(top_builddir)/src/lib/scconfig.h
+
+CLASSTESTS = \
+	classtest \
+	scextest_class
+
+check_PROGRAMS += $(CLASSTESTS)
+noinst_PROGRAMS += $(CLASSTESTS)
+
+CLASSLIBS = \
+	libSCclass.la libSCcontainer.la libSCref.la libSCmisc.la libSCstate.la libSCkeyval.la
+
+classtest_SOURCES = class.cc class.h classtest.cc 
+classtest_LDADD = $(CLASSLIBS)
+
+scextest_class_SOURCES = scextest.cc
+scextest_class_LDADD = $(CLASSLIBS)
+
Index: ThirdParty/mpqc_open/src/lib/util/container/Makefile.am
===================================================================
--- ThirdParty/mpqc_open/src/lib/util/container/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
+++ ThirdParty/mpqc_open/src/lib/util/container/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
@@ -0,0 +1,55 @@
+LIBSCCONTAINERSOURCES = \
+		avl.cc bitarray.cc carray.cc
+
+LIBSCCONTAINERHEADERS = \
+		avlmap.h avlset.h bitarray.h carray.h compare.h eavlmmap.h LIBS.h
+
+lib_LTLIBRARIES +=
+noinst_LTLIBRARIES += libSCcontainer.la
+libSCcontainer_la_includedir = $(includedir)/util/container
+libSCcontainer_la_CPPFLAGS = $(AM_CPPFLAGS)
+libSCcontainer_la_LDFLAGS = $(AM_LDFLAGS)
+libSCcontainer_la_LIBADD =
+
+nobase_libSCcontainer_la_include_HEADERS = ${LIBSCCONTAINERHEADERS}
+
+## Define the source file list for the "libexample-@MPQC_API_VERSION@.la"
+## target.  Note that @MPQC_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libSCcontainer_la_SOURCES = ${LIBSCCONTAINERSOURCES}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+#libSCcontainer_la_LDFLAGS += $(AM_LDFLAGS) -version-info $(MPQC_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+#libSCcontainer_libincludedir = $(libdir)/util/container/include
+#nodist_libSCcontainer_libinclude_HEADERS = $(top_builddir)/src/lib/scconfig.h
+
+CONTAINERTESTS = \
+	avltest
+
+check_PROGRAMS += $(CONTAINERTESTS)
+noinst_PROGRAMS += $(CONTAINERTESTS)
+
+CONTAINERLIBS = \
+	libSCmisc.la libSCkeyval.la libSCstate.la libSCclass.la libSCref.la libSCcontainer.la
+
+avltest_SOURCES = avltest.cc 
+avltest_LDADD = $(CONTAINERLIBS)
Index: ThirdParty/mpqc_open/src/lib/util/group/Makefile.am
===================================================================
--- ThirdParty/mpqc_open/src/lib/util/group/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
+++ ThirdParty/mpqc_open/src/lib/util/group/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
@@ -0,0 +1,119 @@
+LIBSCGROUPSOURCES = \
+	message.cc messimpl.cc messproc.cc messint.cc \
+	reduce.cc topology.cc hcube.cc \
+	rnglock.cc memory.cc memmsg.cc pool.cc \
+	memamsg.cc memproc.cc \
+	pregtime.cc thread.cc memiter.cc memrdma.cc
+
+# file.cc fileproc.cc globcnt.cc hcube.cc memamsg.cc memarmci.cc memiter.cc memmsg.cc memmtmpi.cc memory.cc memproc.cc memrdma.cc memshm.cc message.cc messimpl.cc messint.cc messmpi.cc messproc.cc messshm.cc mstate.cc pool.cc pregtime.cc reduce.cc rnglock.cc thpthd.cc thpuma.cc thread.cc topology.cc
+
+LIBSCGROUPHEADERS = \
+	message.h \
+	topology.h hcube.h \
+	rnglock.h memory.h memmsg.h pool.h \
+	memamsg.h memproc.h \
+	pregtime.h thread.h memiter.h memrdma.h
+
+		
+# file.h fileproc.h globcnt.h hcube.h LIBS.h linkage.h memamsg.h memarmci.h memiter.h memmsg.h memmtmpi.h memory.h memproc.h memrdma.h memshm.h message.h messaget.h messmpi.h messshm.h mstate.h pool.h pregtime.h rnglock.h thpthd.h thpuma.h thread.h topology.h
+
+lib_LTLIBRARIES +=
+noinst_LTLIBRARIES += libSCgroup.la
+libSCgroup_la_includedir = $(includedir)/util/group
+libSCgroup_la_CPPFLAGS = $(AM_CPPFLAGS)
+libSCgroup_la_LDFLAGS = $(AM_LDFLAGS)
+libSCgroup_la_LIBADD =
+
+nobase_libSCgroup_la_include_HEADERS = ${LIBSCGROUPHEADERS}
+
+## Define the source file list for the "libexample-@MPQC_API_VERSION@.la"
+## target.  Note that @MPQC_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libSCgroup_la_SOURCES = ${LIBSCGROUPSOURCES}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+#libSCgroup_la_LDFLAGS += $(AM_LDFLAGS) -version-info $(MPQC_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+#libSCgroup_libincludedir = $(libdir)/util/group/include
+#nodist_libSCgroup_libinclude_HEADERS = $(top_builddir)/src/lib/scconfig.h
+
+GROUPTESTS = \
+	memtest \
+	messtest \
+	pooltest \
+	prttest \
+	rnglocktest \
+	thrtest
+
+check_PROGRAMS += $(GROUPTESTS)
+noinst_PROGRAMS += $(GROUPTESTS)
+
+GROUPLIBS = \
+	libSCgroup.la \
+	libSCkeyval.la \
+	libSCmisc.la \
+	libSCstate.la \
+	libSCclass.la \
+	libSCcontainer.la \
+	libSCref.la
+
+memtest_SOURCES = memtest.cc
+memtest_LDADD = \
+	libSCgroup.la \
+	libSCkeyval.la \
+	libSCmisc.la \
+	libSCstate.la \
+	libSCclass.la \
+	libSCcontainer.la \
+	libSCref.la
+
+messtest_SOURCES = messtest.cc
+messtest_LDADD = \
+	libSCgroup.la \
+	libSCkeyval.la \
+	libSCmisc.la \
+	libSCstate.la \
+	libSCclass.la \
+	libSCcontainer.la \
+	libSCref.la
+
+pooltest_SOURCES = pooltest.cc
+pooltest_LDADD = \
+	$(GROUPLIBS)
+
+prttest_SOURCES = prttest.cc
+prttest_LDADD = \
+	$(GROUPLIBS)
+
+rnglocktest_SOURCES = rnglocktest.cc
+rnglocktest_LDADD = \
+	libSCmisc.la libSCgroup.la
+
+thrtest_SOURCES = thrtest.cc
+thrtest_LDADD = \
+	libSCgroup.la \
+	libSCkeyval.la \
+	libSCmisc.la \
+	libSCstate.la \
+	libSCclass.la \
+	libSCcontainer.la \
+	libSCref.la
+
Index: ThirdParty/mpqc_open/src/lib/util/keyval/Makefile.am
===================================================================
--- ThirdParty/mpqc_open/src/lib/util/keyval/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
+++ ThirdParty/mpqc_open/src/lib/util/keyval/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
@@ -0,0 +1,64 @@
+LIBSCKEYVALSOURCES = \
+		ipv2_alloc.cc ipv2.cc ipv2_cwk.cc ipv2_data.cc ipv2_error.cc ipv2_karray.cc ipv2_parse.cc ipv2_print.cc ipv2_read.cc ipv2_scan.cc keyvalagg.cc keyvalass.cc keyval.cc keyvalipv2.cc keyvalpre.cc keyvalstr.cc keyvalval.cc
+
+LIBSCKEYVALHEADERS = \
+		ipv2.h ipv2_parse.h ipv2_scan.h keyval.h keyvalval.h LIBS.h
+
+lib_LTLIBRARIES +=
+noinst_LTLIBRARIES += libSCkeyval.la
+libSCkeyval_la_includedir = $(includedir)/util/keyval
+libSCkeyval_la_CPPFLAGS = $(AM_CPPFLAGS)
+libSCkeyval_la_LDFLAGS = $(AM_LDFLAGS)
+libSCkeyval_la_LIBADD =
+
+nobase_libSCkeyval_la_include_HEADERS = ${LIBSCKEYVALHEADERS}
+
+## Define the source file list for the "libexample-@MPQC_API_VERSION@.la"
+## target.  Note that @MPQC_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libSCkeyval_la_SOURCES = ${LIBSCKEYVALSOURCES}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+#libSCkeyval_la_LDFLAGS += $(AM_LDFLAGS) -version-info $(MPQC_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+#libSCkeyval_libincludedir = $(libdir)/util/keyval/include
+#nodist_libSCkeyval_libinclude_HEADERS = $(top_builddir)/src/lib/scconfig.h
+
+KEYVALTESTS = \
+	keyvaltest
+
+check_PROGRAMS += $(KEYVALTESTS)
+noinst_PROGRAMS += $(KEYVALTESTS)
+
+KEYVALLIBS = \
+	libSCkeyval.la \
+	libSCcontainer.la \
+	libSCmisc.la \
+	libSCgroup.la \
+	libSCclass.la \
+	libSCstate.la \
+	libSCref.la
+
+keyvaltest_SOURCES = keyvaltest.cc
+keyvaltest_LDADD = \
+	$(KEYVALLIBS)
+
+
Index: ThirdParty/mpqc_open/src/lib/util/misc/Makefile.am
===================================================================
--- ThirdParty/mpqc_open/src/lib/util/misc/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
+++ ThirdParty/mpqc_open/src/lib/util/misc/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
@@ -0,0 +1,93 @@
+LIBSCMISCSOURCES = \
+		bug.cc compute.cc exenv.cc formio.cc ieee.cc regtime.cc units.cc
+# ccaenv.cc
+
+LIBSCMISCHEADERS = \
+		timer.h compute.h ieee.h bug.h exenv.h
+#		autovec.h bug.h ccaenv.h comptmpl.h compute.h exenv.h formio.h ieee.h LIBS.h math.h newstring.h regtime.h scint.h string.h timer.h units.h
+
+lib_LTLIBRARIES +=
+noinst_LTLIBRARIES += libSCmisc.la
+libSCmisc_la_includedir = $(includedir)/util/misc
+libSCmisc_la_CPPFLAGS = $(AM_CPPFLAGS)
+libSCmisc_la_LDFLAGS = $(AM_LDFLAGS)
+libSCmisc_la_LIBADD =
+
+nobase_libSCmisc_la_include_HEADERS = ${LIBSCMISCHEADERS}
+
+## Define the source file list for the "libexample-@MPQC_API_VERSION@.la"
+## target.  Note that @MPQC_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libSCmisc_la_SOURCES = ${LIBSCMISCSOURCES}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+#libSCmisc_la_LDFLAGS += $(AM_LDFLAGS) -version-info $(MPQC_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+#libSCmisc_libincludedir = $(libdir)/util/misc/include
+#nodist_libSCmisc_libinclude_HEADERS = $(top_builddir)/src/lib/scconfig.h
+
+MISCTESTS = \
+	autovectest \
+	comptest \
+	tregtime \
+	scinttest \
+	bugtest \
+	scextest_misc \
+	unittest \
+	formiot
+
+check_PROGRAMS += $(MISCTESTS)
+noinst_PROGRAMS += $(MISCTESTS)
+
+MISCLIBS =
+
+autovectest_SOURCES = autovectest.cc
+autovectest_LDADD = \
+        $(MISCLIBS)
+
+comptest_SOURCES = comptest.cc
+comptest_LDADD = \
+        $(MISCLIBS)
+
+tregtime_SOURCES = tregtime.cc
+tregtime_LDADD = \
+        $(MISCLIBS)
+
+scinttest_SOURCES = scinttest.cc
+scinttest_LDADD = \
+        $(MISCLIBS)
+
+bugtest_SOURCES = bugtest.cc
+bugtest_LDADD = \
+        $(MISCLIBS)
+
+scextest_misc_SOURCES = scextest.cc
+scextest_misc_LDADD = \
+        $(MISCLIBS)
+
+unittest_SOURCES = unittest.cc
+unittest_LDADD = \
+        $(MISCLIBS)
+
+formiot_SOURCES = formiot.cc
+formiot_LDADD = \
+        $(MISCLIBS)
+
Index: ThirdParty/mpqc_open/src/lib/util/options/Makefile.am
===================================================================
--- ThirdParty/mpqc_open/src/lib/util/options/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
+++ ThirdParty/mpqc_open/src/lib/util/options/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
@@ -0,0 +1,58 @@
+LIBSCOPTIONSSOURCES = \
+		GetLongOpt.cc
+
+LIBSCOPTIONSHEADERS = \
+		GetLongOpt.h
+
+lib_LTLIBRARIES +=
+noinst_LTLIBRARIES += libSCoptions.la
+libSCoptions_la_includedir = $(includedir)/util/options
+libSCoptions_la_CPPFLAGS = $(AM_CPPFLAGS)
+libSCoptions_la_LDFLAGS = $(AM_LDFLAGS)
+libSCoptions_la_LIBADD =
+
+nobase_libSCoptions_la_include_HEADERS = ${LIBSCOPTIONSHEADERS}
+
+## Define the source file list for the "libexample-@MPQC_API_VERSION@.la"
+## target.  Note that @MPQC_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libSCoptions_la_SOURCES = ${LIBSCOPTIONSSOURCES}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+#libSCoptions_la_LDFLAGS += $(AM_LDFLAGS) -version-info $(MPQC_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+#libSCoptions_libincludedir = $(libdir)/util/options/include
+#nodist_libSCoptions_libinclude_HEADERS = $(top_builddir)/src/lib/scconfig.h
+
+OPTIONSTESTS = \
+	sample
+
+check_PROGRAMS += $(OPTIONSTESTS)
+noinst_PROGRAMS += $(OPTIONSTESTS)
+
+OPTIONSLIBS = \
+        libSCoptions.la
+
+sample_SOURCES = README.cc
+sample_LDADD = \
+        $(OPTIONSLIBS)
+
+
Index: ThirdParty/mpqc_open/src/lib/util/psi3/libpsio/Makefile.am
===================================================================
--- ThirdParty/mpqc_open/src/lib/util/psi3/libpsio/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
+++ ThirdParty/mpqc_open/src/lib/util/psi3/libpsio/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
@@ -0,0 +1,64 @@
+LIBSCLIBPSIOSOURCES = \
+	init.cc done.cc open.cc close.cc open_check.cc error.cc \
+	rw.cc read.cc write.cc \
+	tocwrite.cc tocread.cc tocscan.cc toclast.cc tocdel.cc tocclean.cc tocprint.cc \
+	get_filename.cc get_numvols.cc get_volpath.cc volseek.cc get_address.cc get_global_address.cc \
+	write_entry.cc read_entry.cc write_block.cc read_block.cc
+#		close.cc done.cc error.cc get_address.cc get_filename.cc get_global_address.cc get_numvols.cc get_volpath.cc init.cc open.cc open_check.cc psiotest.cc read_block.cc read.cc read_entry.cc rw.cc tocclean.cc tocdel.cc toclast.cc tocprint.cc tocread.cc tocscan.cc tocwrite.cc volseek.cc write_block.cc write.cc write_entry.cc
+
+LIBSCLIBPSIOHEADERS = \
+	psio.h psio.gbl
+#		psifiles.h psio.h
+
+lib_LTLIBRARIES +=
+noinst_LTLIBRARIES += libSCpsio.la
+libSCpsio_la_includedir = $(includedir)/util/psi3/libpsio
+libSCpsio_la_CPPFLAGS = $(AM_CPPFLAGS)
+libSCpsio_la_LDFLAGS = $(AM_LDFLAGS)
+libSCpsio_la_LIBADD =
+
+nobase_libSCpsio_la_include_HEADERS = ${LIBSCLIBPSIOHEADERS}
+
+## Define the source file list for the "libexample-@MPQC_API_VERSION@.la"
+## target.  Note that @MPQC_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libSCpsio_la_SOURCES = ${LIBSCLIBPSIOSOURCES}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+#libSCpsio_la_LDFLAGS += $(AM_LDFLAGS) -version-info $(MPQC_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+#libSCpsio_libincludedir = $(libdir)/util/psi3/libpsio/include
+#nodist_libSCpsio_libinclude_HEADERS = $(top_builddir)/src/lib/scconfig.h
+
+PSIOTESTS = \
+        psiotest
+
+check_PROGRAMS += $(PSIOTESTS)
+noinst_PROGRAMS += $(PSIOTESTS)
+
+PSIOLIBS = \
+	libSCpsio.la libSCclass.la libSCcontainer.la libSCref.la libSCmisc.la libSCstate.la libSCkeyval.la
+
+psiotest_SOURCES = psiotest.cc
+psiotest_LDADD = \
+        $(PSIOLIBS)
+
+
Index: ThirdParty/mpqc_open/src/lib/util/ref/Makefile.am
===================================================================
--- ThirdParty/mpqc_open/src/lib/util/ref/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
+++ ThirdParty/mpqc_open/src/lib/util/ref/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
@@ -0,0 +1,59 @@
+LIBSCREFSOURCES = \
+		identity.cc ref.cc
+
+LIBSCREFHEADERS = \
+		identity.h ref.h
+
+lib_LTLIBRARIES +=
+noinst_LTLIBRARIES += libSCref.la
+libSCref_la_includedir = $(includedir)/util/ref
+libSCref_la_CPPFLAGS = $(AM_CPPFLAGS)
+libSCref_la_LDFLAGS = $(AM_LDFLAGS)
+libSCref_la_LIBADD =
+
+nobase_libSCref_la_include_HEADERS = ${LIBSCREFHEADERS}
+
+## Define the source file list for the "libexample-@MPQC_API_VERSION@.la"
+## target.  Note that @MPQC_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libSCref_la_SOURCES = ${LIBSCREFSOURCES}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+#libSCref_la_LDFLAGS += $(AM_LDFLAGS) -version-info $(MPQC_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+#libSCref_libincludedir = $(libdir)/util/ref/include
+#nodist_libSCref_libinclude_HEADERS = $(top_builddir)/src/lib/scconfig.h
+
+REFTESTS = \
+        reftest
+
+check_PROGRAMS += $(REFTESTS)
+noinst_PROGRAMS += $(REFTESTS)
+
+REFLIBS = \
+	libSCkeyval.la \
+	libSCgroup.la libSCstate.la libSCclass.la \
+	libSCcontainer.la libSCref.la libSCmisc.la
+
+reftest_SOURCES = reftest.cc reftextx.cc reftextx.h
+reftest_LDADD = \
+        $(REFLIBS)
+
Index: ThirdParty/mpqc_open/src/lib/util/render/Makefile.am
===================================================================
--- ThirdParty/mpqc_open/src/lib/util/render/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
+++ ThirdParty/mpqc_open/src/lib/util/render/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
@@ -0,0 +1,61 @@
+LIBSCRENDERSOURCES = \
+		algebra3.cc animate.cc appearance.cc color.cc material.cc object.cc oogl.cc polygons.cc polylines.cc polysphere.cc render.cc sphere.cc tempinst.cc transform.cc
+
+LIBSCRENDERHEADERS = \
+		algebra3.h animate.h appearance.h color.h find.h linkage.h material.h object.h oogl.h parameter.h polygons.h polylines.h polysphere.h render.h sphere.h stack.h transform.h
+
+lib_LTLIBRARIES +=
+noinst_LTLIBRARIES += libSCrender.la
+libSCrender_la_includedir = $(includedir)/util/render
+libSCrender_la_CPPFLAGS = $(AM_CPPFLAGS)
+libSCrender_la_LDFLAGS = $(AM_LDFLAGS)
+libSCrender_la_LIBADD =
+
+nobase_libSCrender_la_include_HEADERS = ${LIBSCRENDERHEADERS}
+
+## Define the source file list for the "libexample-@MPQC_API_VERSION@.la"
+## target.  Note that @MPQC_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libSCrender_la_SOURCES = ${LIBSCRENDERSOURCES}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+#libSCrender_la_LDFLAGS += $(AM_LDFLAGS) -version-info $(MPQC_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+#libSCrender_libincludedir = $(libdir)/util/render/include
+#nodist_libSCrender_libinclude_HEADERS = $(top_builddir)/src/lib/scconfig.h
+
+RENDERTESTS = \
+        rentest
+
+check_PROGRAMS += $(RENDERTESTS)
+noinst_PROGRAMS += $(RENDERTESTS)
+
+RENDERLIBS = \
+        libSCkeyval.la \
+        libSCgroup.la libSCrender.la libSCclass.la \
+        libSCcontainer.la libSCref.la libSCmisc.la
+
+rentest_SOURCES = rentest.cc
+rentest_LDADD = \
+        $(RENDERLIBS)
+
+
+
Index: ThirdParty/mpqc_open/src/lib/util/state/Makefile.am
===================================================================
--- ThirdParty/mpqc_open/src/lib/util/state/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
+++ ThirdParty/mpqc_open/src/lib/util/state/Makefile.am	(revision 00f9833f8d74abc94e5b207e00780988a1a0525b)
@@ -0,0 +1,60 @@
+LIBSCSTATESOURCES = \
+		proxy.cc state_bin.cc state.cc state_file.cc statein.cc stateout.cc state_text.cc tmplinst.cc translate.cc
+
+LIBSCSTATEHEADERS = \
+		linkage.h proxy.h state_bin.h state_file.h state.h statein.h stateio.h stateout.h state_text.h translate.h
+
+lib_LTLIBRARIES +=
+noinst_LTLIBRARIES += libSCstate.la
+libSCstate_la_includedir = $(includedir)/util/state
+libSCstate_la_CPPFLAGS = $(AM_CPPFLAGS)
+libSCstate_la_LDFLAGS = $(AM_LDFLAGS)
+libSCstate_la_LIBADD =
+
+nobase_libSCstate_la_include_HEADERS = ${LIBSCSTATEHEADERS}
+
+## Define the source file list for the "libexample-@MPQC_API_VERSION@.la"
+## target.  Note that @MPQC_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libSCstate_la_SOURCES = ${LIBSCSTATESOURCES}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+#libSCstate_la_LDFLAGS += $(AM_LDFLAGS) -version-info $(MPQC_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+#libSCstate_libincludedir = $(libdir)/util/state/include
+#nodist_libSCstate_libinclude_HEADERS = $(top_builddir)/src/lib/scconfig.h
+
+STATETESTS = \
+        statetest
+
+check_PROGRAMS += $(STATETESTS)
+noinst_PROGRAMS += $(STATETESTS)
+
+STATELIBS = \
+        libSCkeyval.la \
+        libSCgroup.la libSCstate.la libSCclass.la \
+        libSCcontainer.la libSCref.la libSCmisc.la
+
+statetest_SOURCES = statetest.cc
+statetest_LDADD = \
+        $(STATELIBS)
+
+